Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1200)
@@ -2052,319 +2224,339 @@
   std::vector<Int> m_tileRowHeight;
 
-  Int      m_numSubstreams;
-
-  Int      m_signHideFlag;
-
-  Bool     m_cabacInitPresentFlag;
-  UInt     m_encCABACTableIdx;           // Used to transmit table selection across slices
-
-  Bool     m_sliceHeaderExtensionPresentFlag;
-  Bool     m_loopFilterAcrossSlicesEnabledFlag;
-  Bool     m_deblockingFilterControlPresentFlag;
-  Bool     m_deblockingFilterOverrideEnabledFlag;
-  Bool     m_picDisableDeblockingFilterFlag;
-  Int      m_deblockingFilterBetaOffsetDiv2;    //< beta offset for deblocking filter
-  Int      m_deblockingFilterTcOffsetDiv2;      //< tc offset for deblocking filter
-  Bool     m_scalingListPresentFlag;
-  TComScalingList*     m_scalingList;   //!< ScalingList class pointer
-  Bool m_listsModificationPresentFlag;
-  UInt m_log2ParallelMergeLevelMinus2;
-  Int m_numExtraSliceHeaderBits;
-
-#if H_MV
-  Int  m_layerId; 
-  Bool m_ppsInferScalingListFlag;
-  Int  m_ppsScalingListRefLayerId;
-
-  Bool m_ppsRangeExtensionsFlag;
-  Bool m_ppsMultilayerExtensionFlag;
-#if !H_3D
-  Int  m_ppsExtension6bits;
-#else
-  Bool m_pps3dExtensionFlag;
-  Int  m_ppsExtension5bits;
-#endif
-
-  Bool m_pocResetInfoPresentFlag;
+  Bool             m_signHideFlag;
+
+  Bool             m_cabacInitPresentFlag;
+
+  Bool             m_sliceHeaderExtensionPresentFlag;
+  Bool             m_loopFilterAcrossSlicesEnabledFlag;
+  Bool             m_deblockingFilterControlPresentFlag;
+  Bool             m_deblockingFilterOverrideEnabledFlag;
+  Bool             m_picDisableDeblockingFilterFlag;
+  Int              m_deblockingFilterBetaOffsetDiv2;    //< beta offset for deblocking filter
+  Int              m_deblockingFilterTcOffsetDiv2;      //< tc offset for deblocking filter
+  Bool             m_scalingListPresentFlag;
+  TComScalingList  m_scalingList;                       //!< ScalingList class
+  Bool             m_listsModificationPresentFlag;
+  UInt             m_log2ParallelMergeLevelMinus2;
+  Int              m_numExtraSliceHeaderBits;
+
+  TComPPSRExt      m_ppsRangeExtension;
+
+#if NH_MV
+  Int              m_layerId; 
+  Bool             m_ppsInferScalingListFlag;
+  Int              m_ppsScalingListRefLayerId;
+                   
+  Bool             m_ppsRangeExtensionsFlag;
+  Bool             m_ppsMultilayerExtensionFlag;
+  Bool             m_pps3dExtensionFlag;
+  Int              m_ppsExtension5bits;
+
+  Bool             m_pocResetInfoPresentFlag;
 #endif
 
 #if H_3D
-  TComDLT*  m_pcDLT; 
+  TComDLT*         m_pcDLT; 
 #endif
 
 public:
-  TComPPS();
-  virtual ~TComPPS();
-  
-  Int       getPPSId ()      { return m_PPSId; }
-  Void      setPPSId (Int i) { m_PPSId = i; }
-  Int       getSPSId ()      { return m_SPSId; }
-  Void      setSPSId (Int i) { m_SPSId = i; }
-  
-  Int       getPicInitQPMinus26 ()         { return  m_picInitQPMinus26; }
-  Void      setPicInitQPMinus26 ( Int i )  { m_picInitQPMinus26 = i;     }
-  Bool      getUseDQP ()                   { return m_useDQP;        }
-  Void      setUseDQP ( Bool b )           { m_useDQP   = b;         }
-  Bool      getConstrainedIntraPred ()         { return  m_bConstrainedIntraPred; }
-  Void      setConstrainedIntraPred ( Bool b ) { m_bConstrainedIntraPred = b;     }
-  Bool      getSliceChromaQpFlag ()         { return  m_bSliceChromaQpFlag; }
-  Void      setSliceChromaQpFlag ( Bool b ) { m_bSliceChromaQpFlag = b;     }
-
-  Void      setSPS              ( TComSPS* pcSPS ) { m_pcSPS = pcSPS; }
-  TComSPS*  getSPS              ()         { return m_pcSPS;          }
-  Void      setMaxCuDQPDepth    ( UInt u ) { m_uiMaxCuDQPDepth = u;   }
-  UInt      getMaxCuDQPDepth    ()         { return m_uiMaxCuDQPDepth;}
-  Void      setMinCuDQPSize     ( UInt u ) { m_uiMinCuDQPSize = u;    }
-  UInt      getMinCuDQPSize     ()         { return m_uiMinCuDQPSize; }
+                         TComPPS();
+  virtual                ~TComPPS();
+
+  Int                    getPPSId() const                                                 { return m_PPSId;                               }
+  Void                   setPPSId(Int i)                                                  { m_PPSId = i;                                  }
+  Int                    getSPSId() const                                                 { return m_SPSId;                               }
+  Void                   setSPSId(Int i)                                                  { m_SPSId = i;                                  }
+
+  Int                    getPicInitQPMinus26() const                                      { return  m_picInitQPMinus26;                   }
+  Void                   setPicInitQPMinus26( Int i )                                     { m_picInitQPMinus26 = i;                       }
+  Bool                   getUseDQP() const                                                { return m_useDQP;                              }
+  Void                   setUseDQP( Bool b )                                              { m_useDQP   = b;                               }
+  Bool                   getConstrainedIntraPred() const                                  { return  m_bConstrainedIntraPred;              }
+  Void                   setConstrainedIntraPred( Bool b )                                { m_bConstrainedIntraPred = b;                  }
+  Bool                   getSliceChromaQpFlag() const                                     { return  m_bSliceChromaQpFlag;                 }
+  Void                   setSliceChromaQpFlag( Bool b )                                   { m_bSliceChromaQpFlag = b;                     }
+
+  Void                   setMaxCuDQPDepth( UInt u )                                       { m_uiMaxCuDQPDepth = u;                        }
+  UInt                   getMaxCuDQPDepth() const                                         { return m_uiMaxCuDQPDepth;                     }
 
 #if H_3D
-  Void      setDLT              ( TComDLT* pcDLT ) { m_pcDLT = pcDLT; }
-  TComDLT*  getDLT              ()                 { return m_pcDLT; }
-#endif
-
-  Void      setChromaCbQpOffset( Int i ) { m_chromaCbQpOffset = i;    }
-  Int       getChromaCbQpOffset()        { return m_chromaCbQpOffset; }
-  Void      setChromaCrQpOffset( Int i ) { m_chromaCrQpOffset = i;    }
-  Int       getChromaCrQpOffset()        { return m_chromaCrQpOffset; }
-
-  Void      setNumRefIdxL0DefaultActive(UInt ui)    { m_numRefIdxL0DefaultActive=ui;     }
-  UInt      getNumRefIdxL0DefaultActive()           { return m_numRefIdxL0DefaultActive; }
-  Void      setNumRefIdxL1DefaultActive(UInt ui)    { m_numRefIdxL1DefaultActive=ui;     }
-  UInt      getNumRefIdxL1DefaultActive()           { return m_numRefIdxL1DefaultActive; }
-
-  Bool getUseWP                     ()          { return m_bUseWeightPred;  }
-  Bool getWPBiPred                  ()          { return m_useWeightedBiPred;     }
-  Void setUseWP                     ( Bool b )  { m_bUseWeightPred = b;     }
-  Void setWPBiPred                  ( Bool b )  { m_useWeightedBiPred = b;  }
-  Void      setOutputFlagPresentFlag( Bool b )  { m_OutputFlagPresentFlag = b;    }
-  Bool      getOutputFlagPresentFlag()          { return m_OutputFlagPresentFlag; }
-  Void      setTransquantBypassEnableFlag( Bool b ) { m_TransquantBypassEnableFlag = b; }
-  Bool      getTransquantBypassEnableFlag()         { return m_TransquantBypassEnableFlag; }
-
-  Bool      getUseTransformSkip       ()         { return m_useTransformSkip;     }
-  Void      setUseTransformSkip       ( Bool b ) { m_useTransformSkip  = b;       }
-
-  Void    setLoopFilterAcrossTilesEnabledFlag  (Bool b)    { m_loopFilterAcrossTilesEnabledFlag = b; }
-  Bool    getLoopFilterAcrossTilesEnabledFlag  ()          { return m_loopFilterAcrossTilesEnabledFlag;   }
-  Bool    getDependentSliceSegmentsEnabledFlag() const     { return m_dependentSliceSegmentsEnabledFlag; }
-  Void    setDependentSliceSegmentsEnabledFlag(Bool val)   { m_dependentSliceSegmentsEnabledFlag = val; }
-  Bool    getEntropyCodingSyncEnabledFlag() const          { return m_entropyCodingSyncEnabledFlag; }
-  Void    setEntropyCodingSyncEnabledFlag(Bool val)        { m_entropyCodingSyncEnabledFlag = val; }
-
-  Void     setTilesEnabledFlag       (Bool val)                             { m_tilesEnabledFlag = val; }
-  Bool     getTilesEnabledFlag       () const                               { return m_tilesEnabledFlag; }
-  Void     setTileUniformSpacingFlag (Bool b)                               { m_uniformSpacingFlag = b; }
-  Bool     getTileUniformSpacingFlag () const                               { return m_uniformSpacingFlag; }
-  Void     setNumTileColumnsMinus1   (Int i)                                { m_numTileColumnsMinus1 = i; }
-  Int      getNumTileColumnsMinus1   () const                               { return m_numTileColumnsMinus1; }
-  Void     setTileColumnWidth        (const std::vector<Int>& columnWidth ) { m_tileColumnWidth = columnWidth; }
-  UInt     getTileColumnWidth        (UInt columnIdx) const                 { return  m_tileColumnWidth[columnIdx]; }
-  Void     setNumTileRowsMinus1      (Int i)                                { m_numTileRowsMinus1 = i; }
-  Int      getTileNumRowsMinus1      () const                               { return m_numTileRowsMinus1; }
-  Void     setTileRowHeight          (const std::vector<Int>& rowHeight)    { m_tileRowHeight = rowHeight;  }
-  UInt     getTileRowHeight          (UInt rowIdx) const                    { return m_tileRowHeight[rowIdx]; }
-
-  Void     setNumSubstreams    (Int numSubstreams)                     { m_numSubstreams = numSubstreams; }
-  Int      getNumSubstreams    ()                                      { return m_numSubstreams; }
-
-  Void      setSignHideFlag( Int signHideFlag ) { m_signHideFlag = signHideFlag; }
-  Int       getSignHideFlag()                    { return m_signHideFlag; }
-
-  Void     setCabacInitPresentFlag( Bool flag )     { m_cabacInitPresentFlag = flag;    }
-  Void     setEncCABACTableIdx( Int idx )           { m_encCABACTableIdx = idx;         }
-  Bool     getCabacInitPresentFlag()                { return m_cabacInitPresentFlag;    }
-  UInt     getEncCABACTableIdx()                    { return m_encCABACTableIdx;        }
-  Void     setDeblockingFilterControlPresentFlag( Bool val )  { m_deblockingFilterControlPresentFlag = val; }
-  Bool     getDeblockingFilterControlPresentFlag()            { return m_deblockingFilterControlPresentFlag; }
-  Void     setDeblockingFilterOverrideEnabledFlag( Bool val ) { m_deblockingFilterOverrideEnabledFlag = val; }
-  Bool     getDeblockingFilterOverrideEnabledFlag()           { return m_deblockingFilterOverrideEnabledFlag; }
-  Void     setPicDisableDeblockingFilterFlag(Bool val)        { m_picDisableDeblockingFilterFlag = val; }       //!< set offset for deblocking filter disabled
-  Bool     getPicDisableDeblockingFilterFlag()                { return m_picDisableDeblockingFilterFlag; }      //!< get offset for deblocking filter disabled
-  Void     setDeblockingFilterBetaOffsetDiv2(Int val)         { m_deblockingFilterBetaOffsetDiv2 = val; }       //!< set beta offset for deblocking filter
-  Int      getDeblockingFilterBetaOffsetDiv2()                { return m_deblockingFilterBetaOffsetDiv2; }      //!< get beta offset for deblocking filter
-  Void     setDeblockingFilterTcOffsetDiv2(Int val)           { m_deblockingFilterTcOffsetDiv2 = val; }               //!< set tc offset for deblocking filter
-  Int      getDeblockingFilterTcOffsetDiv2()                  { return m_deblockingFilterTcOffsetDiv2; }              //!< get tc offset for deblocking filter
-  Bool     getScalingListPresentFlag()         { return m_scalingListPresentFlag;     }
-  Void     setScalingListPresentFlag( Bool b ) { m_scalingListPresentFlag  = b;       }
-  Void     setScalingList      ( TComScalingList *scalingList);
-  TComScalingList* getScalingList ()          { return m_scalingList; }         //!< get ScalingList class pointer in PPS
-  Bool getListsModificationPresentFlag ()          { return m_listsModificationPresentFlag; }
-  Void setListsModificationPresentFlag ( Bool b )  { m_listsModificationPresentFlag = b;    }
-  UInt getLog2ParallelMergeLevelMinus2      ()                    { return m_log2ParallelMergeLevelMinus2; }
-  Void setLog2ParallelMergeLevelMinus2      (UInt mrgLevel)       { m_log2ParallelMergeLevelMinus2 = mrgLevel; }
-  Int getNumExtraSliceHeaderBits() { return m_numExtraSliceHeaderBits; }
-  Void setNumExtraSliceHeaderBits(Int i) { m_numExtraSliceHeaderBits = i; }
-  Void      setLoopFilterAcrossSlicesEnabledFlag ( Bool   bValue  )    { m_loopFilterAcrossSlicesEnabledFlag = bValue; }
-  Bool      getLoopFilterAcrossSlicesEnabledFlag ()                    { return m_loopFilterAcrossSlicesEnabledFlag;   } 
-  Bool getSliceHeaderExtensionPresentFlag   ()                    { return m_sliceHeaderExtensionPresentFlag; }
-  Void setSliceHeaderExtensionPresentFlag   (Bool val)            { m_sliceHeaderExtensionPresentFlag = val; }
-#if H_MV
-  Void setLayerId( Int  val ) { m_layerId = val; } 
-  Int  getLayerId(  ) { return m_layerId; } 
-
-  Void setPpsInferScalingListFlag( Bool flag ) { m_ppsInferScalingListFlag = flag; } 
-  Bool getPpsInferScalingListFlag(  ) { return m_ppsInferScalingListFlag; } 
-
-  Void setPpsScalingListRefLayerId( Int  val ) { m_ppsScalingListRefLayerId = val; } 
-  Int  getPpsScalingListRefLayerId(  ) { return m_ppsScalingListRefLayerId; } 
-
-  Void setPpsRangeExtensionsFlag( Bool flag ) { m_ppsRangeExtensionsFlag = flag; } 
-  Bool getPpsRangeExtensionsFlag(  ) { return m_ppsRangeExtensionsFlag; } 
-
-  Void setPpsMultilayerExtensionFlag( Bool flag ) { m_ppsMultilayerExtensionFlag = flag; } 
-  Bool getPpsMultilayerExtensionFlag(  ) { return m_ppsMultilayerExtensionFlag; } 
-
-#if !H_3D
-  Void setPpsExtension6bits( Int  val ) { m_ppsExtension6bits = val; } 
-  Int  getPpsExtension6bits(  ) { return m_ppsExtension6bits; } 
-#else
-  Void setPps3dExtensionFlag( Bool flag ) { m_pps3dExtensionFlag = flag; } 
-  Bool getPps3dExtensionFlag(  ) { return m_pps3dExtensionFlag; } 
-
-  Void setPpsExtension5bits( Int  val ) { m_ppsExtension5bits = val; } 
-  Int  getPpsExtension5bits(  ) { return m_ppsExtension5bits; } 
-#endif
-
-  Void setPocResetInfoPresentFlag( Bool flag ) { m_pocResetInfoPresentFlag = flag; } 
-  Bool getPocResetInfoPresentFlag(  ) { return m_pocResetInfoPresentFlag; } 
+  Void                   setDLT( TComDLT* pcDLT )                                         { m_pcDLT = pcDLT;                             }
+  TComDLT*               getDLT()                                                         { return m_pcDLT;                              }
+#endif
+
+
+  Void                   setQpOffset(ComponentID compID, Int i )
+  {
+    if      (compID==COMPONENT_Cb)
+    {
+      m_chromaCbQpOffset = i;
+    }
+    else if (compID==COMPONENT_Cr)
+    {
+      m_chromaCrQpOffset = i;
+    }
+    else
+    {
+      assert(0);
+    }
+  }
+  Int                    getQpOffset(ComponentID compID) const
+  {
+    return (compID==COMPONENT_Y) ? 0 : (compID==COMPONENT_Cb ? m_chromaCbQpOffset : m_chromaCrQpOffset );
+  }
+
+  Void                   setNumRefIdxL0DefaultActive(UInt ui)                             { m_numRefIdxL0DefaultActive=ui;                }
+  UInt                   getNumRefIdxL0DefaultActive() const                              { return m_numRefIdxL0DefaultActive;            }
+  Void                   setNumRefIdxL1DefaultActive(UInt ui)                             { m_numRefIdxL1DefaultActive=ui;                }
+  UInt                   getNumRefIdxL1DefaultActive() const                              { return m_numRefIdxL1DefaultActive;            }
+
+  Bool                   getUseWP() const                                                 { return m_bUseWeightPred;                      }
+  Bool                   getWPBiPred() const                                              { return m_useWeightedBiPred;                   }
+  Void                   setUseWP( Bool b )                                               { m_bUseWeightPred = b;                         }
+  Void                   setWPBiPred( Bool b )                                            { m_useWeightedBiPred = b;                      }
+
+  Void                   setOutputFlagPresentFlag( Bool b )                               { m_OutputFlagPresentFlag = b;                  }
+  Bool                   getOutputFlagPresentFlag() const                                 { return m_OutputFlagPresentFlag;               }
+  Void                   setTransquantBypassEnableFlag( Bool b )                          { m_TransquantBypassEnableFlag = b;             }
+  Bool                   getTransquantBypassEnableFlag() const                            { return m_TransquantBypassEnableFlag;          }
+
+  Bool                   getUseTransformSkip() const                                      { return m_useTransformSkip;                    }
+  Void                   setUseTransformSkip( Bool b )                                    { m_useTransformSkip  = b;                      }
+
+  Void                   setLoopFilterAcrossTilesEnabledFlag(Bool b)                      { m_loopFilterAcrossTilesEnabledFlag = b;       }
+  Bool                   getLoopFilterAcrossTilesEnabledFlag() const                      { return m_loopFilterAcrossTilesEnabledFlag;    }
+  Bool                   getDependentSliceSegmentsEnabledFlag() const                     { return m_dependentSliceSegmentsEnabledFlag;   }
+  Void                   setDependentSliceSegmentsEnabledFlag(Bool val)                   { m_dependentSliceSegmentsEnabledFlag = val;    }
+  Bool                   getEntropyCodingSyncEnabledFlag() const                          { return m_entropyCodingSyncEnabledFlag;        }
+  Void                   setEntropyCodingSyncEnabledFlag(Bool val)                        { m_entropyCodingSyncEnabledFlag = val;         }
+
+  Void                   setTilesEnabledFlag(Bool val)                                    { m_tilesEnabledFlag = val;                     }
+  Bool                   getTilesEnabledFlag() const                                      { return m_tilesEnabledFlag;                    }
+  Void                   setTileUniformSpacingFlag(Bool b)                                { m_uniformSpacingFlag = b;                     }
+  Bool                   getTileUniformSpacingFlag() const                                { return m_uniformSpacingFlag;                  }
+  Void                   setNumTileColumnsMinus1(Int i)                                   { m_numTileColumnsMinus1 = i;                   }
+  Int                    getNumTileColumnsMinus1() const                                  { return m_numTileColumnsMinus1;                }
+  Void                   setTileColumnWidth(const std::vector<Int>& columnWidth )         { m_tileColumnWidth = columnWidth;              }
+  UInt                   getTileColumnWidth(UInt columnIdx) const                         { return  m_tileColumnWidth[columnIdx];         }
+  Void                   setNumTileRowsMinus1(Int i)                                      { m_numTileRowsMinus1 = i;                      }
+  Int                    getNumTileRowsMinus1() const                                     { return m_numTileRowsMinus1;                   }
+  Void                   setTileRowHeight(const std::vector<Int>& rowHeight)              { m_tileRowHeight = rowHeight;                  }
+  UInt                   getTileRowHeight(UInt rowIdx) const                              { return m_tileRowHeight[rowIdx];               }
+
+  Void                   setSignHideFlag( Bool signHideFlag )                             { m_signHideFlag = signHideFlag;                }
+  Bool                   getSignHideFlag() const                                          { return m_signHideFlag;                        }
+
+  Void                   setCabacInitPresentFlag( Bool flag )                             { m_cabacInitPresentFlag = flag;                }
+  Bool                   getCabacInitPresentFlag() const                                  { return m_cabacInitPresentFlag;                }
+  Void                   setDeblockingFilterControlPresentFlag( Bool val )                { m_deblockingFilterControlPresentFlag = val;   }
+  Bool                   getDeblockingFilterControlPresentFlag() const                    { return m_deblockingFilterControlPresentFlag;  }
+  Void                   setDeblockingFilterOverrideEnabledFlag( Bool val )               { m_deblockingFilterOverrideEnabledFlag = val;  }
+  Bool                   getDeblockingFilterOverrideEnabledFlag() const                   { return m_deblockingFilterOverrideEnabledFlag; }
+  Void                   setPicDisableDeblockingFilterFlag(Bool val)                      { m_picDisableDeblockingFilterFlag = val;       } //!< set offset for deblocking filter disabled
+  Bool                   getPicDisableDeblockingFilterFlag() const                        { return m_picDisableDeblockingFilterFlag;      } //!< get offset for deblocking filter disabled
+  Void                   setDeblockingFilterBetaOffsetDiv2(Int val)                       { m_deblockingFilterBetaOffsetDiv2 = val;       } //!< set beta offset for deblocking filter
+  Int                    getDeblockingFilterBetaOffsetDiv2() const                        { return m_deblockingFilterBetaOffsetDiv2;      } //!< get beta offset for deblocking filter
+  Void                   setDeblockingFilterTcOffsetDiv2(Int val)                         { m_deblockingFilterTcOffsetDiv2 = val;         } //!< set tc offset for deblocking filter
+  Int                    getDeblockingFilterTcOffsetDiv2() const                          { return m_deblockingFilterTcOffsetDiv2;        } //!< get tc offset for deblocking filter
+  Bool                   getScalingListPresentFlag() const                                { return m_scalingListPresentFlag;              }
+  Void                   setScalingListPresentFlag( Bool b )                              { m_scalingListPresentFlag  = b;                }
+  TComScalingList&       getScalingList()                                                 { return m_scalingList;                         }
+  const TComScalingList& getScalingList() const                                           { return m_scalingList;                         }
+  Bool                   getListsModificationPresentFlag() const                          { return m_listsModificationPresentFlag;        }
+  Void                   setListsModificationPresentFlag( Bool b )                        { m_listsModificationPresentFlag = b;           }
+  UInt                   getLog2ParallelMergeLevelMinus2() const                          { return m_log2ParallelMergeLevelMinus2;        }
+  Void                   setLog2ParallelMergeLevelMinus2(UInt mrgLevel)                   { m_log2ParallelMergeLevelMinus2 = mrgLevel;    }
+  Int                    getNumExtraSliceHeaderBits() const                               { return m_numExtraSliceHeaderBits;             }
+  Void                   setNumExtraSliceHeaderBits(Int i)                                { m_numExtraSliceHeaderBits = i;                }
+  Void                   setLoopFilterAcrossSlicesEnabledFlag( Bool bValue )              { m_loopFilterAcrossSlicesEnabledFlag = bValue; }
+  Bool                   getLoopFilterAcrossSlicesEnabledFlag() const                     { return m_loopFilterAcrossSlicesEnabledFlag;   }
+  Bool                   getSliceHeaderExtensionPresentFlag() const                       { return m_sliceHeaderExtensionPresentFlag;     }
+  Void                   setSliceHeaderExtensionPresentFlag(Bool val)                     { m_sliceHeaderExtensionPresentFlag = val;      }
+
+
+  const TComPPSRExt&     getPpsRangeExtension() const                                     { return m_ppsRangeExtension;                   }
+  TComPPSRExt&           getPpsRangeExtension()                                           { return m_ppsRangeExtension;                   }
+
+  // WAS: getTransformSkipLog2MaxSize and setTransformSkipLog2MaxSize
+  // Now: getPpsRangeExtension().getLog2MaxTransformSkipBlockSize and getPpsRangeExtension().setLog2MaxTransformSkipBlockSize
+
+  // WAS: getUseCrossComponentPrediction and setUseCrossComponentPrediction
+  // Now: getPpsRangeExtension().getCrossComponentPredictionEnabledFlag and getPpsRangeExtension().setCrossComponentPredictionEnabledFlag
+
+  // WAS: clearChromaQpAdjTable
+  // Now: getPpsRangeExtension().clearChromaQpOffsetList
+
+  // WAS: getMaxCuChromaQpAdjDepth and setMaxCuChromaQpAdjDepth
+  // Now: getPpsRangeExtension().getDiffCuChromaQpOffsetDepth and getPpsRangeExtension().setDiffCuChromaQpOffsetDepth
+
+  // WAS: getChromaQpAdjTableSize
+  // Now: getPpsRangeExtension().getChromaQpOffsetListLen
+
+  // WAS: getChromaQpAdjTableAt and setChromaQpAdjTableAt
+  // Now: getPpsRangeExtension().getChromaQpOffsetListEntry and getPpsRangeExtension().setChromaQpOffsetListEntry
+
+  // WAS: getSaoOffsetBitShift and setSaoOffsetBitShift
+  // Now: getPpsRangeExtension().getLog2SaoOffsetScale and getPpsRangeExtension().setLog2SaoOffsetScale
+
+#if NH_MV
+  Void    setLayerId( Int  val )                                                     { m_layerId = val;                                           }
+  Int     getLayerId(  ) const                                                       { return m_layerId;                                          }
+
+  Void    setPpsInferScalingListFlag( Bool flag )                                    { m_ppsInferScalingListFlag = flag;                          }
+  Bool    getPpsInferScalingListFlag(  ) const                                       { return m_ppsInferScalingListFlag;                          }
+
+  Void    setPpsScalingListRefLayerId( Int  val )                                    { m_ppsScalingListRefLayerId = val;                          }
+  Int     getPpsScalingListRefLayerId(  ) const                                      { return m_ppsScalingListRefLayerId;                         }
+
+  Void    setPpsRangeExtensionsFlag( Bool flag )                                     { m_ppsRangeExtensionsFlag = flag;                           }
+  Bool    getPpsRangeExtensionsFlag(  ) const                                        { return m_ppsRangeExtensionsFlag;                           }
+
+  Void    setPpsMultilayerExtensionFlag( Bool flag )                                 { m_ppsMultilayerExtensionFlag = flag;                       }
+  Bool    getPpsMultilayerExtensionFlag(  ) const                                    { return m_ppsMultilayerExtensionFlag;                       }
+
+  Void    setPps3dExtensionFlag( Bool flag )                                         { m_pps3dExtensionFlag = flag;                               }
+  Bool    getPps3dExtensionFlag(  ) const                                            { return m_pps3dExtensionFlag;                               }
+
+  Void    setPpsExtension5bits( Int  val )                                           { m_ppsExtension5bits = val;                                 }
+  Int     getPpsExtension5bits(  ) const                                             { return m_ppsExtension5bits;                                }
+
+  Void    setPocResetInfoPresentFlag( Bool flag )                                    { m_pocResetInfoPresentFlag = flag;                          }
+  Bool    getPocResetInfoPresentFlag(  ) const                                       { return m_pocResetInfoPresentFlag;                          }
 #endif
 };
-
-typedef struct
+struct WPScalingParam
 {
   // Explicit weighted prediction parameters parsed in slice header,
   // or Implicit weighted prediction parameters (8 bits depth values).
-  Bool        bPresentFlag;
-  UInt        uiLog2WeightDenom;
-  Int         iWeight;
-  Int         iOffset;
+  Bool bPresentFlag;
+  UInt uiLog2WeightDenom;
+  Int  iWeight;
+  Int  iOffset;
 
   // Weighted prediction scaling values built from above parameters (bitdepth scaled):
-  Int         w, o, offset, shift, round;
-} wpScalingParam;
-
-typedef struct
+  Int  w;
+  Int  o;
+  Int  offset;
+  Int  shift;
+  Int  round;
+};
+
+struct WPACDCParam
 {
   Int64 iAC;
   Int64 iDC;
-} wpACDCParam;
+};
 
 /// slice header class
 class TComSlice
 {
-  
+
 private:
   //  Bitstream writing
-  Bool       m_saoEnabledFlag;
-  Bool       m_saoEnabledFlagChroma;      ///< SAO Cb&Cr enabled flag
-  Int         m_iPPSId;               ///< picture parameter set ID
-  Bool        m_PicOutputFlag;        ///< pic_output_flag 
-#if H_MV
-  Int         m_slicePicOrderCntLsb;   
+  Bool                       m_saoEnabledFlag[MAX_NUM_CHANNEL_TYPE];
+  Int                        m_iPPSId;               ///< picture parameter set ID
+  Bool                       m_PicOutputFlag;        ///< pic_output_flag
+#if NH_MV
+  Int                        m_slicePicOrderCntLsb;   
 #endif  
-  Int         m_iPOC;
-#if H_MV
-  Int         m_iPOCBeforeReset; 
-#endif
-  Int         m_iLastIDR;
-  Int         m_iAssociatedIRAP;
-  NalUnitType m_iAssociatedIRAPType;
-  static Int  m_prevTid0POC;
-  TComReferencePictureSet *m_pcRPS;
-  TComReferencePictureSet m_LocalRPS;
-  Int         m_iBDidx; 
+  Int                        m_iPOC;
+#if NH_MV
+  Int                        m_iPOCBeforeReset; 
+#endif
+  Int                        m_iLastIDR;
+  Int                        m_iAssociatedIRAP;
+  NalUnitType                m_iAssociatedIRAPType;
+  TComReferencePictureSet*   m_pcRPS;
+  TComReferencePictureSet    m_LocalRPS;
+  Int                        m_iBDidx;
   TComRefPicListModification m_RefPicListModification;
-  NalUnitType m_eNalUnitType;         ///< Nal unit type for the slice
-  SliceType   m_eSliceType;
-  Int         m_iSliceQp;
-  Bool        m_dependentSliceSegmentFlag;
+  NalUnitType                m_eNalUnitType;         ///< Nal unit type for the slice
+  SliceType                  m_eSliceType;
+  Int                        m_iSliceQp;
+  Bool                       m_dependentSliceSegmentFlag;
 #if ADAPTIVE_QP_SELECTION
-  Int         m_iSliceQpBase;
-#endif
-  Bool        m_deblockingFilterDisable;
-  Bool        m_deblockingFilterOverrideFlag;      //< offsets for deblocking filter inherit from PPS
-  Int         m_deblockingFilterBetaOffsetDiv2;    //< beta offset for deblocking filter
-  Int         m_deblockingFilterTcOffsetDiv2;      //< tc offset for deblocking filter
-  Int         m_list1IdxToList0Idx[MAX_NUM_REF];
-  Int         m_aiNumRefIdx   [2];    //  for multiple reference of current slice
-
-  Bool        m_bCheckLDC;
+  Int                        m_iSliceQpBase;
+#endif
+  Bool                       m_ChromaQpAdjEnabled;
+  Bool                       m_deblockingFilterDisable;
+  Bool                       m_deblockingFilterOverrideFlag;      //< offsets for deblocking filter inherit from PPS
+  Int                        m_deblockingFilterBetaOffsetDiv2;    //< beta offset for deblocking filter
+  Int                        m_deblockingFilterTcOffsetDiv2;      //< tc offset for deblocking filter
+  Int                        m_list1IdxToList0Idx[MAX_NUM_REF];
+  Int                        m_aiNumRefIdx   [NUM_REF_PIC_LIST_01];    //  for multiple reference of current slice
+
+  Bool                       m_bCheckLDC;
 
   //  Data
-  Int         m_iSliceQpDelta;
-  Int         m_iSliceQpDeltaCb;
-  Int         m_iSliceQpDeltaCr;
-  TComPic*    m_apcRefPicList [2][MAX_NUM_REF+1];
-  Int         m_aiRefPOCList  [2][MAX_NUM_REF+1];
-#if H_MV
+  Int                        m_iSliceQpDelta;
+  Int                        m_iSliceChromaQpDelta[MAX_NUM_COMPONENT];
+  TComPic*                   m_apcRefPicList [NUM_REF_PIC_LIST_01][MAX_NUM_REF+1];
+  Int                        m_aiRefPOCList  [NUM_REF_PIC_LIST_01][MAX_NUM_REF+1];
+#if NH_MV
   Int         m_aiRefLayerIdList[2][MAX_NUM_REF+1];
 #endif
-  Bool        m_bIsUsedAsLongTerm[2][MAX_NUM_REF+1];
-  Int         m_iDepth;
-  
+  Bool                       m_bIsUsedAsLongTerm[NUM_REF_PIC_LIST_01][MAX_NUM_REF+1];
+  Int                        m_iDepth;
+
   // referenced slice?
-  Bool        m_bRefenced;
-  
+  Bool                       m_bRefenced;
+
   // access channel
-  TComVPS*    m_pcVPS;
-  TComSPS*    m_pcSPS;
-  TComPPS*    m_pcPPS;
-  TComPic*    m_pcPic;
-#if ADAPTIVE_QP_SELECTION
-  TComTrQuant* m_pcTrQuant;
-#endif  
-  UInt        m_colFromL0Flag;  // collocated picture from List0 flag
-  
-#if SETTING_NO_OUT_PIC_PRIOR
-  Bool        m_noOutputPriorPicsFlag;
-  Bool        m_noRaslOutputFlag;
-  Bool        m_handleCraAsBlaFlag;
-#endif
-  
-  UInt        m_colRefIdx;
-  UInt        m_maxNumMergeCand;
-
-  Double      m_lambdas[3];
-
-  Bool        m_abEqualRef  [2][MAX_NUM_REF][MAX_NUM_REF];
-  UInt        m_uiTLayer;
-  Bool        m_bTLayerSwitchingFlag;
-
-  UInt        m_sliceMode;
-  UInt        m_sliceArgument;
-  UInt        m_sliceCurStartCUAddr;
-  UInt        m_sliceCurEndCUAddr;
-  UInt        m_sliceIdx;
-  UInt        m_sliceSegmentMode;
-  UInt        m_sliceSegmentArgument;
-  UInt        m_sliceSegmentCurStartCUAddr;
-  UInt        m_sliceSegmentCurEndCUAddr;
-  Bool        m_nextSlice;
-  Bool        m_nextSliceSegment;
-  UInt        m_sliceBits;
-  UInt        m_sliceSegmentBits;
-  Bool        m_bFinalized;
-
-  wpScalingParam  m_weightPredTable[2][MAX_NUM_REF][3]; // [REF_PIC_LIST_0 or REF_PIC_LIST_1][refIdx][0:Y, 1:U, 2:V]
-  wpACDCParam    m_weightACDCParam[3];                 // [0:Y, 1:U, 2:V]
-
-  std::vector<UInt> m_tileByteLocation;
-  UInt        m_uiTileOffstForMultES;
-
-  UInt*       m_puiSubstreamSizes;
-  TComScalingList*     m_scalingList;                 //!< pointer of quantization matrix
-  Bool        m_cabacInitFlag; 
-
-  Bool       m_bLMvdL1Zero;
-  Int         m_numEntryPointOffsets;
-  Bool       m_temporalLayerNonReferenceFlag;
-  Bool       m_LFCrossSliceBoundaryFlag;
-
-  Bool       m_enableTMVPFlag;
-#if H_MV
+  const TComVPS*             m_pcVPS;
+  const TComSPS*             m_pcSPS;
+  const TComPPS*             m_pcPPS;
+  TComPic*                   m_pcPic;
+  Bool                       m_colFromL0Flag;  // collocated picture from List0 flag
+
+  Bool                       m_noOutputPriorPicsFlag;
+  Bool                       m_noRaslOutputFlag;
+  Bool                       m_handleCraAsBlaFlag;
+
+  UInt                       m_colRefIdx;
+  UInt                       m_maxNumMergeCand;
+
+  Double                     m_lambdas[MAX_NUM_COMPONENT];
+
+  Bool                       m_abEqualRef  [NUM_REF_PIC_LIST_01][MAX_NUM_REF][MAX_NUM_REF];
+  UInt                       m_uiTLayer;
+  Bool                       m_bTLayerSwitchingFlag;
+
+  SliceConstraint            m_sliceMode;
+  UInt                       m_sliceArgument;
+  UInt                       m_sliceCurStartCtuTsAddr;
+  UInt                       m_sliceCurEndCtuTsAddr;
+  UInt                       m_sliceIdx;
+  SliceConstraint            m_sliceSegmentMode;
+  UInt                       m_sliceSegmentArgument;
+  UInt                       m_sliceSegmentCurStartCtuTsAddr;
+  UInt                       m_sliceSegmentCurEndCtuTsAddr;
+  Bool                       m_nextSlice;
+  Bool                       m_nextSliceSegment;
+  UInt                       m_sliceBits;
+  UInt                       m_sliceSegmentBits;
+  Bool                       m_bFinalized;
+
+  Bool                       m_bTestWeightPred;
+  Bool                       m_bTestWeightBiPred;
+  WPScalingParam             m_weightPredTable[NUM_REF_PIC_LIST_01][MAX_NUM_REF][MAX_NUM_COMPONENT]; // [REF_PIC_LIST_0 or REF_PIC_LIST_1][refIdx][0:Y, 1:U, 2:V]
+  WPACDCParam                m_weightACDCParam[MAX_NUM_COMPONENT];
+
+  std::vector<UInt>          m_substreamSizes;
+
+  Bool                       m_cabacInitFlag;
+
+  Bool                       m_bLMvdL1Zero;
+  Bool                       m_temporalLayerNonReferenceFlag;
+  Bool                       m_LFCrossSliceBoundaryFlag;
+
+  Bool                       m_enableTMVPFlag;
+
+  SliceType                  m_encCABACTableIdx;           // Used to transmit table selection across slices.
+#if NH_MV
   Bool       m_availableForTMVPRefFlag;
 #endif
 
-#if H_MV
+#if NH_MV
   std::vector<TComPic*>* m_refPicSetInterLayer0; 
   std::vector<TComPic*>* m_refPicSetInterLayer1; 
